unit LMat;

interface

uses Windows;

//
//  The following bits are used with Flags field in structures below.
//

//
//  Do we exec programs for this job periodically (/EVERY switch)
//  or one time (/NEXT switch).
//
const JOB_RUN_PERIODICALLY            = $01;    //  set if EVERY


//
//  Was there an error last time we tried to exec a program on behalf of
//  this job.
//  This flag is meaningfull on output only!
//
const JOB_EXEC_ERROR                  = $02;    //  set if error

//
//  Will this job run today or tomorrow.
//  This flag is meaningfull on output only!
//
const JOB_RUNS_TODAY                  = $04;    //  set if today

//
//  Add current day of the month to DaysOfMonth input.
//  This flag is meaningfull on input only!
//
const JOB_ADD_CURRENT_DATE            = $08;    // set if to add current date


//
//  Will this job be run interactively or not.  Windows NT 3.1 do not
//  know about this bit, i.e. they submit interactive jobs only.
//
const JOB_NONINTERACTIVE              = $10;    // set for noninteractive


const JOB_INPUT_FLAGS    = (  JOB_RUN_PERIODICALLY        or
                              JOB_ADD_CURRENT_DATE        or
                              JOB_NONINTERACTIVE  );

const JOB_OUTPUT_FLAGS   = (  JOB_RUN_PERIODICALLY        or
                              JOB_EXEC_ERROR              or
                              JOB_RUNS_TODAY              or
                              JOB_NONINTERACTIVE  );



type
  _AT_INFO = record
    JobTime     : DWORD;
    DaysOfMonth : DWORD;
    DaysOfWeek  : UCHAR;
    Flags       : UCHAR;
    Command     : LPWSTR;
  end;
  AT_INFO = _AT_INFO;
  PAT_INFO = ^_AT_INFO;
  LPAT_INFO = ^_AT_INFO;

  _AT_ENUM = record
    JobId       : DWORD;
    JobTime     : DWORD;
    DaysOfMonth : DWORD;
    DaysOfWeek  : UCHAR;
    Flags       : UCHAR;
    Command     : LPWSTR;
  end;
  AT_ENUM = _AT_ENUM;
  PAT_ENUM = ^_AT_ENUM;
  LPAT_ENUM = ^_AT_ENUM;

function NetScheduleJobAdd(
  Servername : LPCWSTR         ;
  Buffer     : PBYTE           ;
  JobId      : LPDWORD
  ): DWORD; stdcall;

function NetScheduleJobDel(
  Servername : LPCWSTR;
  MinJobId   : DWORD;
  MaxJobId   : DWORD
  ): DWORD; stdcall;

function NetScheduleJobEnum(
  Servername             : LPCWSTR;
  PointerToBuffer        : PBYTE;
  PrefferedMaximumLength : DWORD;
  EntriesRead            : LPDWORD;
  TotalEntries           : LPDWORD;
  ResumeHandle           : LPDWORD
  ): DWORD; stdcall;

function NetScheduleJobGetInfo(
  Servername      : LPCWSTR;
  JobId           : DWORD;
  PointerToBuffer : PBYTE
  ): DWORD; stdcall;

implementation

const
  na32 = 'NETAPI32.DLL';

function NetScheduleJobAdd; external na32 name 'NetScheduleJobAdd';
function NetScheduleJobDel; external na32 name 'NetScheduleJobDel';
function NetScheduleJobEnum; external na32 name 'NetScheduleJobEnum';
function NetScheduleJobGetInfo; external na32 name 'NetScheduleJobGetInfo';

end.
